Filter Class Reference

Abstract base class for data analysis operations. More...

`#include <Filter.h>`

Inheritance diagram for Filter:

## Public Member Functions

int | dataSize ()
| Returns the size of the input data set. More...
virtual void | enableGraphicsDisplay (bool on=true, Graph *g=0)
bool | error ()
| Filter (ApplicationWindow *parent, Table *t=0, const QString &name=QString())
| Filter (ApplicationWindow *parent, Graph *g=0, const QString &name=QString())
| Filter (ApplicationWindow *parent, Matrix *m, const QString &name=QString())
| Filter (ApplicationWindow *parent, QwtPlotCurve *c)
virtual QString | legendInfo ()
| Output string added to the plot as a new legend. More...
Graph * | outputGraph ()
| Returns a pointer to the graph where the result curve should be displayed. More...
QwtPlotCurve * | resultCurve ()
| Returns a pointer to the plot curve created to display the results. More...
Table * | resultTable ()
| Returns a pointer to the table created to display the results. More...
virtual bool | run ()
| Actually does the job. Should be reimplemented in derived classes. More...
void | setColor (int colorId)
| Obsolete: sets the color of the output fit curve. More...
void | setColor (const QColor &color)
| Sets the color of the output fit curve. More...
void | setColor (const QString &colorName)
| Sets the color of the output fit curve. Provided for convenience. To be used in scripts only! More...
virtual void | setDataCurve (QwtPlotCurve *curve, double start, double end)
bool | setDataFromCurve (QwtPlotCurve *c)
bool | setDataFromCurve (QwtPlotCurve *c, double from, double to)
bool | setDataFromCurve (const QString &curveTitle, Graph *g=0)
bool | setDataFromCurve (const QString &curveTitle, double from, double to, Graph *g=0)
virtual bool | setDataFromTable (Table *, const QString &, const QString &, int=1, int=-1, bool=false)
void | setError (bool on=true)
void | setInterval (double from, double to)
| Changes the data range if the source curve was already assigned. Provided for convenience. More...
void | setMaximumIterations (int iter)
| Sets the maximum number of iterations to be performed during an iterative session. More...
void | setOutputPoints (int points)
| Sets the number of points in the output curve. More...
void | setOutputPrecision (int digits)
| Sets the precision used for the output. More...
void | setSortData (bool on=true)
void | setTolerance (double eps)
| Sets the tolerance used by the GSL routines. More...
void | setUpdateOutputGraph (bool update=true)
virtual void | showLegend ()
| Adds a new legend to the plot. Calls virtual legendInfo() More...
double * | x ()
| Returns the x values of the input data set. More...
double * | y ()
| Returns the y values of the input data set. More...
| ~Filter ()

## Protected Member Functions

QwtPlotCurve * | addResultCurve (double *x, double *y)
| Adds the result curve to the target output plot window. Creates a hidden table and frees the input data from memory. More...
virtual void | calculateOutputData (double *X, double *Y)
| Calculates the data for the output curve and store it in the X an Y vectors. More...
MultiLayer * | createOutputGraph ()
virtual int | curveData (QwtPlotCurve *c, double start, double end, double **x, double **y)
int | curveIndex (const QString &curveTitle, Graph *g)
| Performs checks and returns the index of the source data curve if OK, -1 otherwise. More...
int | curveRange (QwtPlotCurve *c, double start, double end, int *iStart, int *iEnd)
virtual void | freeMemory ()
| Frees the memory allocated for the X and Y data sets. More...
void | init ()
virtual QString | logInfo ()
| Output string added to the log pannel of the application. More...
void | memoryErrorMessage ()
virtual void | output ()
| Performs the data analysis and takes care of the output. More...
virtual int | sortedCurveData (QwtPlotCurve *c, double start, double end, double **x, double **y)
| Same as curveData, but sorts the points by their x value. More...

## Protected Attributes

QwtPlotCurve * | d_curve
| The curve to be analysed. More...
QColor | d_curveColor
| Color index of the result curve. More...
QString | d_explanation
| String explaining the operation in the comment of the result table and in the project explorer. More...
double | d_from
| Data interval. More...
Graph * | d_graph
| The source graph with the curve to be analyzed. More...
bool | d_graphics_display
| Specifies if the filter should display a result curve. More...
bool | d_init_err
| Error flag telling if something went wrong during the initialization phase. More...
Matrix * | d_matrix
int | d_max_iterations
| Maximum number of iterations per fit. More...
int | d_min_points
| Minimum number of data points necessary to perform the operation. More...
int | d_n
| Size of the data arrays. More...
Graph * | d_output_graph
| The graph where the result curve should be displayed. More...
int | d_points
| Number of result points to de calculated and displayed in the output curve. More...
int | d_prec
| Precision (number of significant digits) used for the results output. More...
QwtPlotCurve * | d_result_curve
| The resulting curve. More...
Table * | d_result_table
| The table displaying the results of the filtering operation (not alvays valid!) More...
bool | d_sort_data
| Specifies if the filter needs sorted data as input. More...
Table * | d_table
| A table source of data. More...
double | d_to
double | d_tolerance
| GSL Tolerance, if ever needed... More...
bool | d_update_output_graph
| Specifies if the filter should update the output graph. More...
double * | d_x
| x data set to be analysed More...
double * | d_y
| y data set to be analysed More...
QString | d_y_col_name

## Detailed Description

Abstract base class for data analysis operations.

## Constructor & Destructor Documentation

## Filter() [1/4]

Filter::Filter | ( | ApplicationWindow * | parent,
|  | Table * | t = `0`,
|  | const QString & | name = `QString()`
| ) |  |

References d_table, and init().

## Filter() [2/4]

Filter::Filter | ( | ApplicationWindow * | parent,
|  | Graph * | g = `0`,
|  | const QString & | name = `QString()`
| ) |  |

References d_graph, d_output_graph, and init().

## Filter() [3/4]

Filter::Filter | ( | ApplicationWindow * | parent,
|  | Matrix * | m,
|  | const QString & | name = `QString()`
| ) |  |

References d_matrix, and init().

## Filter() [4/4]

Filter::Filter | ( | ApplicationWindow * | parent,
|  | QwtPlotCurve * | c
| ) |  |

References init().

## ~Filter()

Filter::~Filter | ( |  | ) |

References d_n, and freeMemory().

## Member Function Documentation

## addResultCurve()

QwtPlotCurve * Filter::addResultCurve | ( | double * | x,
|  | double * | y
| ) |  |

protected

Adds the result curve to the target output plot window. Creates a hidden table and frees the input data from memory.

References createOutputGraph(), d_curve, d_curveColor, ApplicationWindow::d_decimal_digits, d_explanation, d_graphics_display, d_output_graph, d_points, d_result_curve, d_result_table, d_update_output_graph, d_y_col_name, ApplicationWindow::generateUniqueName(), Graph::insertPlotItem(), Graph::Line, ApplicationWindow::newHiddenTable(), Table::setText(), and Graph::updatePlot().

Referenced by Fit::generateFitCurve(), output(), setUpdateOutputGraph(), and Integration::trapez().

## calculateOutputData()

virtual void Filter::calculateOutputData | ( | double * | X,
|  | double * | Y
| ) |  |

inline protected virtual

Calculates the data for the output curve and store it in the X an Y vectors.

Reimplemented in FFTFilter, SmoothFilter, and Interpolation.

References createOutputGraph().

Referenced by output().

## createOutputGraph()

MultiLayer * Filter::createOutputGraph | ( |  | ) |

protected

References MultiLayer::activeLayer(), d_output_graph, and ApplicationWindow::newGraph().

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), addResultCurve(), calculateOutputData(), enableGraphicsDisplay(), MultiPeakFit::generateFitCurve(), Fit::generateFitCurve(), Differentiation::output(), FFT::outputGraphs(), Fit::showConfidenceLimits(), Fit::showPredictionLimits(), and Fit::showResiduals().

## curveData()

int Filter::curveData | ( | QwtPlotCurve * | c,
|  | double | start,
|  | double | end,
|  | double ** | x,
|  | double ** | y
| ) |  |

protected virtual

Sets x and y to the curve points between start and end. Memory will be allocated with new double[]. Returns the number of points within range == size of x and y arrays.

References curveRange(), and memoryErrorMessage().

Referenced by setDataCurve(), and setUpdateOutputGraph().

## curveIndex()

int Filter::curveIndex | ( | const QString & | curveTitle,
|  | Graph * | g
| ) |  |

protected

Performs checks and returns the index of the source data curve if OK, -1 otherwise.

References Graph::curveIndex(), d_graph, d_init_err, and d_output_graph.

Referenced by setDataFromCurve(), and setUpdateOutputGraph().

## curveRange()

int Filter::curveRange | ( | QwtPlotCurve * | c,
|  | double | start,
|  | double | end,
|  | int * | iStart,
|  | int * | iEnd
| ) |  |

protected

Referenced by curveData(), setUpdateOutputGraph(), and sortedCurveData().

## dataSize()

int Filter::dataSize | ( |  | ) |

inline

Returns the size of the input data set.

References d_n.

Referenced by FitDialog::closeEvent(), MultiPeakFitTool::finalize(), FitDialog::showConfidenceLimits(), FitDialog::showCovarianceMatrix(), FitDialog::showParametersTable(), FitDialog::showPredictionLimits(), and FitDialog::showResiduals().

## enableGraphicsDisplay()

void Filter::enableGraphicsDisplay | ( | bool | on = `true`,
|  | Graph * | g = `0`
| ) |  |

virtual

References createOutputGraph(), d_graphics_display, and d_output_graph.

Referenced by IntDialog::accept(), ApplicationWindow::analyzeCurve(), IntegrationDialog::integrateCurve(), IntegrationDialog::integrateTable(), and setError().

## error()

bool Filter::error | ( |  | ) |

inline

References d_init_err.

Referenced by IntDialog::accept(), evalFunction(), Fit::residuals(), SmoothFilter::savitzkyGolayCoefficients(), Fit::setWeightingData(), FitDialog::showFitPage(), and SmoothFilter::smoothSavGol().

## freeMemory()

void Filter::freeMemory | ( |  | ) |

protected virtual

Frees the memory allocated for the X and Y data sets.

Reimplemented in Fit.

References d_x, and d_y.

Referenced by Fit::freeMemory(), setDataCurve(), Correlation::setDataFromTable(), Convolution::setDataFromTable(), FFT::setDataFromTable(), setDataFromTable(), setUpdateOutputGraph(), and ~Filter().

## init()

void Filter::init | ( |  | ) |

protected

References d_curve, d_curveColor, d_explanation, d_graph, d_graphics_display, d_init_err, d_matrix, d_max_iterations, d_min_points, d_n, d_output_graph, d_points, d_prec, d_result_curve, d_result_table, d_sort_data, d_table, d_tolerance, d_update_output_graph, and d_y_col_name.

Referenced by FFTFilter::enableOffset(), FFTFilter::FFTFilter(), Filter(), Interpolation::Interpolation(), SmoothFilter::method(), Interpolation::method(), setUpdateOutputGraph(), and SmoothFilter::SmoothFilter().

## legendInfo()

virtual QString Filter::legendInfo | ( |  | ) |

inline virtual

Output string added to the plot as a new legend.

Reimplemented in Fit, NonLinearFit, and PolynomialFit.

Referenced by showLegend().

## logInfo()

virtual QString Filter::logInfo | ( |  | ) |

inline protected virtual

Output string added to the log pannel of the application.

Reimplemented in Integration.

References output().

Referenced by run().

## memoryErrorMessage()

void Filter::memoryErrorMessage | ( |  | ) |

protected

References d_init_err.

Referenced by curveData(), FFT::fftCurve(), FFT::fftTable(), MultiPeakFit::generateFitCurve(), output(), Fit::setDataCurve(), Correlation::setDataFromTable(), FFT::setDataFromTable(), setDataFromTable(), Fit::setDataFromTable(), setUpdateOutputGraph(), Fit::setWeightingData(), SmoothFilter::smoothSavGol(), Interpolation::sortedCurveData(), and sortedCurveData().

## output()

void Filter::output | ( |  | ) |

protected virtual

Performs the data analysis and takes care of the output.

Reimplemented in Deconvolution, FFT, Integration, Convolution, Correlation, and Differentiation.

References addResultCurve(), calculateOutputData(), d_init_err, d_points, memoryErrorMessage(), x(), and y().

Referenced by logInfo(), and run().

## outputGraph()

Graph* Filter::outputGraph | ( |  | ) |

inline

Returns a pointer to the graph where the result curve should be displayed.

References d_output_graph.

Referenced by ApplicationWindow::differentiate(), ApplicationWindow::fitLinear(), and ApplicationWindow::fitSlope().

## resultCurve()

QwtPlotCurve* Filter::resultCurve | ( |  | ) |

inline

Returns a pointer to the plot curve created to display the results.

References d_result_curve.

Referenced by FitDialog::accept().

## resultTable()

Table* Filter::resultTable | ( |  | ) |

inline

Returns a pointer to the table created to display the results.

References d_result_table.

## run()

bool Filter::run | ( |  | ) |

virtual

Actually does the job. Should be reimplemented in derived classes.

Reimplemented in Fit.

References d_init_err, d_matrix, d_n, logInfo(), and output().

Referenced by IntDialog::accept(), FFTDialog::accept(), ApplicationWindow::analyzeCurve(), ApplicationWindow::autoCorrelate(), ApplicationWindow::convolute(), ApplicationWindow::correlate(), BaselineDialog::createBaseline(), ApplicationWindow::deconvolute(), ApplicationWindow::differentiate(), FFTDialog::fftMatrix(), FilterDialog::filter(), IntegrationDialog::integrateCurve(), IntegrationDialog::integrateTable(), InterpolationDialog::interpolate(), and SmoothCurveDialog::smooth().

## setColor() [1/3]

void Filter::setColor | ( | int | colorId | ) |

Obsolete: sets the color of the output fit curve.

References d_curveColor, and ColorBox::defaultColor().

Referenced by FitDialog::accept(), FilterDialog::filter(), ExpDecayDialog::fit(), PolynomFitDialog::fit(), ApplicationWindow::fitLinear(), ApplicationWindow::fitSlope(), InterpolationDialog::interpolate(), setColor(), setTolerance(), and SmoothCurveDialog::smooth().

## setColor() [2/3]

void Filter::setColor | ( | const QColor & | color | ) |

inline

Sets the color of the output fit curve.

References d_curveColor, and setColor().

## setColor() [3/3]

void Filter::setColor | ( | const QString & | colorName | ) |

Sets the color of the output fit curve. Provided for convenience. To be used in scripts only!

References d_curveColor, and ColorBox::isValidColor().

## setDataCurve()

void Filter::setDataCurve | ( | QwtPlotCurve * | curve,
|  | double | start,
|  | double | end
| ) |  |

virtual

Reimplemented in Fit.

References curveData(), d_curve, d_from, d_init_err, d_min_points, d_n, d_sort_data, d_to, d_x, d_y, freeMemory(), and sortedCurveData().

Referenced by Fit::setDataCurve(), and setDataFromCurve().

## setDataFromCurve() [1/4]

bool Filter::setDataFromCurve | ( | QwtPlotCurve * | c | ) |

References d_from, d_graph, d_init_err, d_output_graph, d_to, Graph::range(), and setDataCurve().

Referenced by FitDialog::accept(), ApplicationWindow::analyzeCurve(), Differentiation::Differentiation(), ExponentialFit::ExponentialFit(), FFT::FFT(), FFTFilter::FFTFilter(), MultiPeakFitTool::finalize(), PolynomFitDialog::fit(), ExpDecayDialog::fit(), ApplicationWindow::fitLinear(), ApplicationWindow::fitSlope(), GaussAmpFit::GaussAmpFit(), GaussFit::GaussFit(), FitDialog::guessInitialValues(), IntegrationDialog::integrateCurve(), Integration::Integration(), Interpolation::Interpolation(), LinearFit::LinearFit(), LinearSlopeFit::LinearSlopeFit(), LogisticFit::LogisticFit(), LorentzFit::LorentzFit(), NonLinearFit::NonLinearFit(), PluginFit::PluginFit(), PolynomialFit::PolynomialFit(), setInterval(), SigmoidalFit::SigmoidalFit(), SmoothFilter::SmoothFilter(), ThreeExpFit::ThreeExpFit(), and TwoExpFit::TwoExpFit().

## setDataFromCurve() [2/4]

bool Filter::setDataFromCurve | ( | QwtPlotCurve * | c,
|  | double | from,
|  | double | to
| ) |  |

References d_graph, d_init_err, d_output_graph, and setDataCurve().

## setDataFromCurve() [3/4]

bool Filter::setDataFromCurve | ( | const QString & | curveTitle,
|  | Graph * | g = `0`
| ) |  |

References Graph::curve(), curveIndex(), d_from, d_graph, d_init_err, d_to, Graph::range(), and setDataCurve().

## setDataFromCurve() [4/4]

bool Filter::setDataFromCurve | ( | const QString & | curveTitle,
|  | double | from,
|  | double | to,
|  | Graph * | g = `0`
| ) |  |

References Graph::curve(), curveIndex(), d_graph, d_init_err, and setDataCurve().

## setDataFromTable()

bool Filter::setDataFromTable | ( | Table * | t,
|  | const QString & | xColName,
|  | const QString & | yColName,
|  | int | startRow = `1`,
|  | int | endRow = `-1`,
|  | bool | sort = `false`
| ) |  |

virtual

Reimplemented in Fit, and FFT.

References Table::colIndex(), Table::colName(), Table::columnType(), d_curve, d_from, d_graph, d_init_err, d_min_points, d_n, d_sort_data, d_table, d_to, d_x, d_y, d_y_col_name, freeMemory(), memoryErrorMessage(), Table::Numeric, Table::numRows(), and Table::text().

Referenced by ApplicationWindow::differentiate(), Differentiation::Differentiation(), FFTFilter::FFTFilter(), Integration::Integration(), Interpolation::Interpolation(), Fit::setDataFromTable(), and SmoothFilter::SmoothFilter().

## setError()

void Filter::setError | ( | bool | on = `true` | ) |

inline

References d_init_err, and enableGraphicsDisplay().

## setInterval()

void Filter::setInterval | ( | double | from,
|  | double | to
| ) |  |

Changes the data range if the source curve was already assigned. Provided for convenience.

References d_curve, and setDataFromCurve().

## setMaximumIterations()

void Filter::setMaximumIterations | ( | int | iter | ) |

inline

Sets the maximum number of iterations to be performed during an iterative session.

References d_max_iterations.

Referenced by FitDialog::accept().

## setOutputPoints()

void Filter::setOutputPoints | ( | int | points | ) |

inline

Sets the number of points in the output curve.

References d_points.

Referenced by BaselineDialog::createBaseline(), and InterpolationDialog::interpolate().

## setOutputPrecision()

void Filter::setOutputPrecision | ( | int | digits | ) |

inline

Sets the precision used for the output.

References d_prec.

Referenced by FitDialog::accept(), ApplicationWindow::analyzeCurve(), FitDialog::applyChanges(), ExpDecayDialog::fit(), PolynomFitDialog::fit(), ApplicationWindow::fitLinear(), and ApplicationWindow::fitSlope().

## setSortData()

void Filter::setSortData | ( | bool | on = `true` | ) |

inline

References d_sort_data, and showLegend().

Referenced by IntegrationDialog::integrateCurve().

## setTolerance()

void Filter::setTolerance | ( | double | eps | ) |

inline

Sets the tolerance used by the GSL routines.

References d_tolerance, and setColor().

Referenced by IntDialog::accept(), and FitDialog::accept().

## setUpdateOutputGraph()

void Filter::setUpdateOutputGraph | ( | bool | update = `true` | ) |

inline

References addResultCurve(), curveData(), curveIndex(), curveRange(), d_update_output_graph, freeMemory(), init(), memoryErrorMessage(), sortedCurveData(), x(), and y().

Referenced by ApplicationWindow::differentiate(), ApplicationWindow::fitLinear(), and ApplicationWindow::fitSlope().

## showLegend()

void Filter::showLegend | ( |  | ) |

virtual

Adds a new legend to the plot. Calls virtual legendInfo()

References d_output_graph, Graph::enrichmentsList(), LegendWidget::isAutoUpdateEnabled(), legendInfo(), Graph::newLegend(), LegendWidget::setText(), and LegendWidget::text().

Referenced by ApplicationWindow::analyzeCurve(), ExpDecayDialog::closeEvent(), FitDialog::closeEvent(), PolynomialFit::fit(), and setSortData().

## sortedCurveData()

int Filter::sortedCurveData | ( | QwtPlotCurve * | c,
|  | double | start,
|  | double | end,
|  | double ** | x,
|  | double ** | y
| ) |  |

protected virtual

Same as curveData, but sorts the points by their x value.

Reimplemented in Interpolation.

References curveRange(), and memoryErrorMessage().

Referenced by setDataCurve(), and setUpdateOutputGraph().

## x()

double* Filter::x | ( |  | ) |

inline

Returns the x values of the input data set.

References d_x.

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), LogisticFit::calculateFitCurveData(), PluginFit::calculateFitCurveData(), ExponentialFit::calculateFitCurveData(), SigmoidalFit::calculateFitCurveData(), PolynomialFit::calculateFitCurveData(), NonLinearFit::calculateFitCurveData(), TwoExpFit::calculateFitCurveData(), LinearFit::calculateFitCurveData(), ThreeExpFit::calculateFitCurveData(), LinearSlopeFit::calculateFitCurveData(), GaussAmpFit::calculateFitCurveData(), FFTFilter::enableOffset(), LinearFit::eval(), LinearSlopeFit::eval(), evalFunction(), MultiPeakFitTool::finalize(), LogisticFit::guessInitialValues(), SigmoidalFit::guessInitialValues(), SmoothFilter::method(), Interpolation::method(), PolynomialFit::order(), output(), MultiPeakFit::setPeakCurvesColor(), setUpdateOutputGraph(), Fit::showConfidenceLimits(), and Fit::showPredictionLimits().

## y()

double* Filter::y | ( |  | ) |

inline

Returns the y values of the input data set.

References d_y.

Referenced by Correlation::addResultCurve(), FFTFilter::enableOffset(), PolynomialFit::eval(), MultiPeakFit::eval(), MultiPeakFitTool::finalize(), PolynomialFit::fit(), LogisticFit::guessInitialValues(), SigmoidalFit::guessInitialValues(), Interpolation::method(), SmoothFilter::method(), output(), Fit::rSquare(), setUpdateOutputGraph(), Fit::showConfidenceLimits(), and Fit::showPredictionLimits().

## Member Data Documentation

## d_curve

QwtPlotCurve* Filter::d_curve

protected

The curve to be analysed.

Referenced by addResultCurve(), MultiPeakFit::generateFitCurve(), init(), Fit::init(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), Fit::legendInfo(), Fit::logFitInfo(), Integration::logInfo(), Differentiation::output(), FFT::output(), setDataCurve(), Fit::setDataCurve(), FFT::setDataFromTable(), setDataFromTable(), setInterval(), and Fit::setWeightingData().

## d_curveColor

QColor Filter::d_curveColor

protected

Color index of the result curve.

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), addResultCurve(), MultiPeakFit::generateFitCurve(), init(), Fit::init(), Fit::insertFitFunctionCurve(), FFT::outputGraphs(), setColor(), Fit::showConfidenceLimits(), Fit::showPredictionLimits(), and Fit::showResiduals().

## d_explanation

QString Filter::d_explanation

protected

String explaining the operation in the comment of the result table and in the project explorer.

Referenced by addResultCurve(), SmoothFilter::calculateOutputData(), FFTFilter::calculateOutputData(), MultiPeakFit::generateFitCurve(), PluginFit::init(), LogisticFit::init(), ExponentialFit::init(), SigmoidalFit::init(), Interpolation::init(), PolynomialFit::init(), NonLinearFit::init(), TwoExpFit::init(), LinearFit::init(), ThreeExpFit::init(), LinearSlopeFit::init(), LorentzFit::init(), GaussFit::init(), init(), GaussAmpFit::init(), Fit::init(), Fit::logFitInfo(), FFT::output(), Interpolation::setMethod(), MultiPeakFit::setNumPeaks(), Fit::showConfidenceLimits(), Fit::showPredictionLimits(), and Fit::showResiduals().

## d_from

double Filter::d_from

protected

Data interval.

Referenced by Interpolation::calculateOutputData(), Integration::gslIntegration(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), Integration::Integration(), Integration::logInfo(), Integration::output(), setDataCurve(), setDataFromCurve(), setDataFromTable(), Fit::showConfidenceLimits(), and Fit::showPredictionLimits().

## d_graph

Graph* Filter::d_graph

protected

The source graph with the curve to be analyzed.

Referenced by curveIndex(), Filter(), Fit::fit(), init(), Integration::logInfo(), FFT::output(), Fit::setDataCurve(), setDataFromCurve(), FFT::setDataFromTable(), setDataFromTable(), and Fit::setWeightingData().

## d_graphics_display

bool Filter::d_graphics_display

protected

Specifies if the filter should display a result curve.

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), addResultCurve(), enableGraphicsDisplay(), MultiPeakFit::generateFitCurve(), Fit::generateFitCurve(), init(), Fit::logFitInfo(), Differentiation::output(), FFT::output(), Integration::output(), Fit::showConfidenceLimits(), Fit::showPredictionLimits(), and Fit::showResiduals().

## d_init_err

bool Filter::d_init_err

protected

Error flag telling if something went wrong during the initialization phase.

Referenced by curveIndex(), error(), PolynomialFit::fit(), Fit::fit(), LinearFit::fit(), LinearSlopeFit::fit(), Integration::gslIntegration(), Interpolation::init(), init(), Fit::init(), Integration::Integration(), Integration::logInfo(), memoryErrorMessage(), Integration::output(), output(), run(), FFTFilter::setBand(), setDataCurve(), setDataFromCurve(), Convolution::setDataFromTable(), Correlation::setDataFromTable(), FFT::setDataFromTable(), setDataFromTable(), setError(), FFTFilter::setFilterType(), NonLinearFit::setFormula(), SmoothFilter::setLowessParameter(), SmoothFilter::setMethod(), Interpolation::setMethod(), NonLinearFit::setParametersList(), SmoothFilter::setPolynomOrder(), SmoothFilter::setSmoothPoints(), and SmoothFilter::smoothSavGol().

## d_matrix

Matrix* Filter::d_matrix

protected

Referenced by FFT::fftMatrix(), Filter(), init(), FFT::output(), FFT::outputGraphs(), and run().

## d_max_iterations

int Filter::d_max_iterations

protected

Maximum number of iterations per fit.

Referenced by Fit::fit(), Fit::fitGSL(), Fit::fitSimplex(), init(), Fit::init(), and setMaximumIterations().

## d_min_points

int Filter::d_min_points

protected

Minimum number of data points necessary to perform the operation.

Referenced by Differentiation::init(), Interpolation::init(), LinearFit::init(), LinearSlopeFit::init(), init(), Fit::initWorkspace(), setDataCurve(), setDataFromTable(), and Interpolation::setMethod().

## d_n

int Filter::d_n

protected

Size of the data arrays.

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), LogisticFit::calculateFitCurveData(), PluginFit::calculateFitCurveData(), ExponentialFit::calculateFitCurveData(), SigmoidalFit::calculateFitCurveData(), PolynomialFit::calculateFitCurveData(), NonLinearFit::calculateFitCurveData(), TwoExpFit::calculateFitCurveData(), LinearFit::calculateFitCurveData(), ThreeExpFit::calculateFitCurveData(), LinearSlopeFit::calculateFitCurveData(), GaussAmpFit::calculateFitCurveData(), Interpolation::calculateOutputData(), FFTFilter::calculateOutputData(), dataSize(), Fit::errors(), FFT::fftCurve(), FFT::fftTable(), PolynomialFit::fit(), Fit::fit(), LinearFit::fit(), LinearSlopeFit::fit(), Fit::fitGSL(), MultiPeakFit::generateFitCurve(), Fit::generateFitCurve(), LogisticFit::guessInitialValues(), SigmoidalFit::guessInitialValues(), MultiPeakFit::guessInitialValues(), GaussAmpFit::guessInitialValues(), SmoothFilter::init(), FFTFilter::init(), init(), Fit::init(), Integration::Integration(), Fit::lcl(), Fit::legendInfo(), Fit::logFitInfo(), Integration::logInfo(), Correlation::output(), Differentiation::output(), FFT::output(), NonLinearFit::removeDataSingularities(), NonLinearFit::removePole(), Fit::residuals(), Fit::rmse(), Fit::rSquare(), run(), setDataCurve(), Fit::setDataCurve(), Convolution::setDataFromTable(), Correlation::setDataFromTable(), FFT::setDataFromTable(), setDataFromTable(), Fit::setDataFromTable(), Interpolation::setMethod(), Fit::setWeightingData(), Fit::showConfidenceLimits(), Fit::showPredictionLimits(), Fit::showResiduals(), SmoothFilter::smoothAverage(), SmoothFilter::smoothFFT(), SmoothFilter::smoothLowess(), SmoothFilter::smoothSavGol(), Integration::trapez(), Fit::ucl(), Fit::writeParametersToTable(), and ~Filter().

## d_output_graph

Graph* Filter::d_output_graph

protected

The graph where the result curve should be displayed.

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), addResultCurve(), createOutputGraph(), curveIndex(), enableGraphicsDisplay(), FFT::FFT(), Filter(), MultiPeakFit::generateFitCurve(), Fit::generateFitCurve(), FFT::init(), init(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), Fit::logFitInfo(), Differentiation::output(), Integration::output(), outputGraph(), FFT::outputGraphs(), setDataFromCurve(), Fit::showConfidenceLimits(), showLegend(), Fit::showPredictionLimits(), and Fit::showResiduals().

## d_points

int Filter::d_points

protected

Number of result points to de calculated and displayed in the output curve.

Referenced by addResultCurve(), LogisticFit::calculateFitCurveData(), PluginFit::calculateFitCurveData(), ExponentialFit::calculateFitCurveData(), SigmoidalFit::calculateFitCurveData(), PolynomialFit::calculateFitCurveData(), NonLinearFit::calculateFitCurveData(), TwoExpFit::calculateFitCurveData(), LinearFit::calculateFitCurveData(), ThreeExpFit::calculateFitCurveData(), LinearSlopeFit::calculateFitCurveData(), GaussAmpFit::calculateFitCurveData(), Interpolation::calculateOutputData(), SmoothFilter::calculateOutputData(), FFTFilter::calculateOutputData(), MultiPeakFit::generateFitCurve(), Fit::generateFitCurve(), Fit::generateFunction(), SmoothFilter::init(), FFTFilter::init(), init(), Fit::init(), NonLinearFit::insertFitFunctionCurve(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), Integration::output(), output(), setOutputPoints(), Fit::showConfidenceLimits(), Fit::showPredictionLimits(), and Integration::trapez().

## d_prec

int Filter::d_prec

protected

Precision (number of significant digits) used for the results output.

Referenced by Fit::covarianceMatrix(), MultiPeakFit::generateFitCurve(), init(), Fit::init(), PolynomialFit::legendInfo(), NonLinearFit::legendInfo(), Fit::legendInfo(), NonLinearFit::logFitInfo(), MultiPeakFit::logFitInfo(), Fit::logFitInfo(), setOutputPrecision(), and Fit::writeParametersToTable().

## d_result_curve

QwtPlotCurve* Filter::d_result_curve

protected

The resulting curve.

Referenced by addResultCurve(), init(), Fit::insertFitFunctionCurve(), and resultCurve().

## d_result_table

Table* Filter::d_result_table

protected

The table displaying the results of the filtering operation (not alvays valid!)

Referenced by addResultCurve(), FFT::fftCurve(), FFT::fftTable(), MultiPeakFit::generateFitCurve(), init(), Correlation::output(), Differentiation::output(), Convolution::output(), FFT::output(), Deconvolution::output(), FFT::outputGraphs(), and resultTable().

## d_sort_data

bool Filter::d_sort_data

protected

Specifies if the filter needs sorted data as input.

Referenced by Differentiation::init(), Interpolation::init(), Integration::init(), init(), Fit::init(), Integration::Integration(), setDataCurve(), setDataFromTable(), and setSortData().

## d_table

Table* Filter::d_table

protected

A table source of data.

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), Filter(), Fit::fit(), init(), Correlation::output(), Convolution::output(), FFT::output(), Deconvolution::output(), Convolution::setDataFromTable(), Correlation::setDataFromTable(), FFT::setDataFromTable(), setDataFromTable(), and Fit::setWeightingData().

## d_to

double Filter::d_to

protected

Referenced by Interpolation::calculateOutputData(), Integration::gslIntegration(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), Integration::Integration(), Integration::logInfo(), Integration::output(), setDataCurve(), setDataFromCurve(), setDataFromTable(), Fit::showConfidenceLimits(), and Fit::showPredictionLimits().

## d_tolerance

double Filter::d_tolerance

protected

GSL Tolerance, if ever needed...

Referenced by Fit::fitGSL(), Fit::fitSimplex(), Integration::gslIntegration(), init(), Fit::init(), Fit::logFitInfo(), Integration::logInfo(), and setTolerance().

## d_update_output_graph

bool Filter::d_update_output_graph

protected

Specifies if the filter should update the output graph.

Referenced by addResultCurve(), Fit::generateFitCurve(), init(), Differentiation::output(), and setUpdateOutputGraph().

## d_x

double* Filter::d_x

protected

x data set to be analysed

Referenced by Correlation::addResultCurve(), Convolution::addResultCurve(), LogisticFit::calculateFitCurveData(), PluginFit::calculateFitCurveData(), ExponentialFit::calculateFitCurveData(), SigmoidalFit::calculateFitCurveData(), PolynomialFit::calculateFitCurveData(), NonLinearFit::calculateFitCurveData(), TwoExpFit::calculateFitCurveData(), LinearFit::calculateFitCurveData(), ThreeExpFit::calculateFitCurveData(), LinearSlopeFit::calculateFitCurveData(), GaussAmpFit::calculateFitCurveData(), Interpolation::calculateOutputData(), SmoothFilter::calculateOutputData(), FFTFilter::calculateOutputData(), FFT::fftCurve(), FFT::fftTable(), PolynomialFit::fit(), Fit::fit(), LinearFit::fit(), LinearSlopeFit::fit(), freeMemory(), MultiPeakFit::generateFitCurve(), LogisticFit::guessInitialValues(), SigmoidalFit::guessInitialValues(), MultiPeakFit::guessInitialValues(), GaussAmpFit::guessInitialValues(), Fit::init(), Fit::logFitInfo(), Integration::logInfo(), Differentiation::output(), Correlation::output(), Convolution::output(), Deconvolution::output(), NonLinearFit::removeDataSingularities(), NonLinearFit::removePole(), Fit::residuals(), Fit::rSquare(), setDataCurve(), Convolution::setDataFromTable(), Correlation::setDataFromTable(), FFT::setDataFromTable(), setDataFromTable(), Fit::showConfidenceLimits(), Fit::showPredictionLimits(), Fit::showResiduals(), SmoothFilter::smoothFFT(), Integration::trapez(), and x().

## d_y

double* Filter::d_y

protected

y data set to be analysed

Referenced by Interpolation::calculateOutputData(), SmoothFilter::calculateOutputData(), FFTFilter::calculateOutputData(), FFT::fftCurve(), FFT::fftTable(), PolynomialFit::fit(), Fit::fit(), LinearFit::fit(), LinearSlopeFit::fit(), freeMemory(), LogisticFit::guessInitialValues(), SigmoidalFit::guessInitialValues(), MultiPeakFit::guessInitialValues(), GaussAmpFit::guessInitialValues(), Fit::init(), Integration::logInfo(), Differentiation::output(), Correlation::output(), Convolution::output(), Deconvolution::output(), NonLinearFit::removePole(), Fit::residuals(), Fit::rSquare(), setDataCurve(), Correlation::setDataFromTable(), Convolution::setDataFromTable(), FFT::setDataFromTable(), setDataFromTable(), Fit::setWeightingData(), Integration::trapez(), and y().

## d_y_col_name

QString Filter::d_y_col_name

protected

Referenced by addResultCurve(), MultiPeakFit::generateFitCurve(), init(), Fit::legendInfo(), Fit::logFitInfo(), Integration::logInfo(), Differentiation::output(), setDataFromTable(), and Fit::setWeightingData().

The documentation for this class was generated from the following files:

- qtiplot/src/analysis/Filter.h
- qtiplot/src/analysis/Filter.cpp